'www.PredictiveEngineering.com
'All Rights Reserved, 2013
'Predictive Engineering Assumes No Responsibility For Results Obtained From API
'~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
'This API was originally coded for FEMAP v11.0.1
'Written by Adrian Jensen
'This API will create vectors with the GFXArrow Object

Sub Main
    Dim App As femap.model
    Set App = feFemap()

	App.feAppMessage(FCM_ERROR,"Generate GFX ArrowsMeasure")

	'option: delete previous gxf elements
	Dim delPrevGFK As Long
	delPrevGFX = App.feAppMessageBox(3,"Do you want to delete all previous graphic elements?")

	Dim ar As femap.GFXArrow, txt As femap.text
	Set ar = App.feGFXArrow
	Set txt = App.feText

	Dim GFXSet As femap.Set
	Set GFXSet = App.feSet
	GFXSet.ID = 1

	If delPrevGFX = FE_CANCEL Then
		Exit Sub
	ElseIf delprevGFX = FE_OK Then
		ar.DeleteAll(True,1)  'delete arrows
		App.feGFXSelect(GFXSet.ID,True,True)

		App.feViewRegenerate(0)
	End If

	Do  'infinite loop - user presses cancel to get out
    	Dim vecLength As Double, vecBase As Variant, vecDir As Variant
    	If App.feVectorPick("Select Vector for GFX Arrow",False,vecLength,vecBase,vecDir) = FE_CANCEL Then
    		Exit Sub
    	End If

    	'ar.ID = GFXSet.Count+1
    	ar.ID = ar.NextEmptyID
		ar.style = 1
		ar.lengthmode = GAM_ABSOLUTE
'~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
'Vector Colors: 4=red; 14=orange; 24=yellow; 20=green; 100=blue
		ar.color = 20
'~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
		ar.x = vecBase(0)
		ar.y = vecBase(1)
		ar.z = vecBase(2)
		ar.dX = vecDir(0)*vecLength
		ar.dY =vecDir(1)*vecLength
		ar.dZ = vecDir(2)*vecLength
		ar.Length = Sqr((ar.dX)^2+(ar.dY)^2+(ar.dZ)^2)

		ar.Put(ar.ID)
		GFXSet.Add(ar.ID)
		App.feGFXSelect(GFXSet.ID,True,True)

		App.feViewRegenerate(0)  'regenerate active view so as to display textboxes
	Loop
End Sub
